# main menu for xtem_TeXMenu
#
# called from shell script xtem: 
# exec $wishcall -f $XTEMPATH/xtem.tcl -n xtem $wishcall $XTEMPATH $language $*
# (instead of "#!/usr/local/bin/wishx -f" at the beginning of this file!)
#
# Copyright (C) 1994  G. Lamprecht, W. Lotz, R. Weibezahn; LRW c/o Univ. Bremen
# Copyright (C) 1996  G. Lamprecht, W. Lotz, R. Weibezahn; IWD, Bremen University
#
###################################################################

set copyright "Copyright 1996  G. Lamprecht, W. Lotz, R. Weibezahn; "
set copyright "${copyright}LRW/IWD, Bremen University"
set email     "e-mail: weibezahn@iwd.uni-bremen.de"
set www       "WWW:    http://ftp.iwd.uni-bremen.de/xtem/xtem_texmenu.html"

set wishcall "[lindex $argv 0]"
set xtem_path "[lindex $argv 1]"
set language "[lindex $argv 2]"
set fln "[lindex $argv 3]"
if {$fln=="__Test_Put"} {set testPut 1; set fln "[lindex $argv 4]"; incr argc -1} \
else {set testPut 0}
if {[lindex $argv 4]=="__Test_Put"} {set testPut 1; incr argc -1}

if {($argc<3)||($argc>4)} {
  puts stdout "call:  xtem \[ -l language \] \[ filename\[.tex\] \]"
  if ![file exists $xtem_path/xtem.tcl] \
	{puts stdout "if call is OK: check shell-script \"xtem\" (new version; see README)!"}
  exit
}

if ![file exists $xtem_path/xtem.tcl] \
	{puts stdout "check shell-script \"xtem\" (new version; see README)!"; exit}

set bell_level 3; source $xtem_path/ut.tcl; source $xtem_path/xV.tcl;# read xtem version

set auto_path "$xtem_path $auto_path"

set texsuffix ".tex";  set esuff  ".tex"

set v ""; set n ""
set l [string length $fln]; set p [string last . $fln]
if {$p<0} {
  set main_file $fln; set efile $fln; set texsuffix .tex; set esuff .tex
} elseif {$p==[expr [string length $fln]-1]} {
  set main_file [crange $fln 0 $p-1]; set efile $main_file; set texsuffix .tex; set esuff .tex
} else {
  if {$p==0} {set b ""; set e $fln} \
  else {set b [crange $fln 0 $p-1]; set e [crange $fln $p end]}
  if {($e==".tex")||($e==".ltx")} {
    set main_file $b; set efile $b; set texsuffix $e; set esuff $e
  } else {
    set main_file $fln; set efile $fln; set texsuffix ""; set esuff ""
  }
}

set InstDir "$xtem_path/locals_$language"
if [info exists env(XTEMVSTDIR)] {set InstDir "$env(XTEMVSTDIR):$InstDir"}

set hlp_dir "$xtem_path/help_$language/"
set f [open "${hlp_dir}button.texts" r]
while {[gets $f z]>=0} {
	set z "[string trim $z] "; set p [string first " " $z]
	set vv([crange $z 0 $p-1]) [string trim [crange $z $p end]]
}
close $f

proc xtem_hlptext {} {
 global  vv copyright email www version tclversion patchlevel tk_version
 global  tk_patchLevel extended addinput InstDir tcl_platform mkcommand TeXSyntaxHelpOwnButton
 if {$TeXSyntaxHelpOwnButton==1} {HTxtFile0 "" xt_xtem .d.tt} {HTxtFile0 "" xt_xtemold .d.tt}
 set cprt "$copyright\n$email\n$www\n\n"
 set cprt "${cprt}xtem:$version Tcl:$patchlevel Tk:$tk_patchLevel "
 set cprt "${cprt}$extended $addinput $mkcommand\n"
 if {$tclversion>=7.5} {set cprt "${cprt}     [array get tcl_platform]\n"};#system information
 set cprt "${cprt}InstDir: $InstDir\n\n"
 set cprt "${cprt}$vv(xtcprt1)\n$vv(xtcprt2)"
 if {[info exists vv(xtdlm1)]&&($vv(xtdlm1)!="")} {set cprt "${cprt}\n\n$vv(xtdlm1)"}
 if {[info exists vv(xtdlm2)]&&($vv(xtdlm2)!="")} {set cprt "${cprt}\n$vv(xtdlm2)"}
 writescr .d.tt $cprt
}

proc xtemWb2ln {} {
 global sub xtem_path language localnews
 lock;  set sub 1
 if [file exists "$xtem_path/../xtem_locals_$language/local.news"] \
      {set localnews "$xtem_path/../xtem_locals_$language/local.news"} \
 else {set localnews "$xtem_path/locals_$language.LRW/local.news"}
 newsfile .d.tt austext; writescr .d.tt "$austext"
 unlock_list
}


set tssk(1) yes; set tssk(2) icon; set tssk(3) no; set edsyntaxchg 0

####### set your variables in the files  locals_*/*.vst --- not here
####### the follwoing settings are  only for "security" (initialization of all variables)!!!
set mdatsort 0; set edatsort 0; set button2end 2; set fsmenucols 2
set vlerg ""
set widthl   41
set widthr   45
set sizeds   100x10
set maxprintcops 1
set xtermcall xterm
set edsyntaxhelp $tssk(2)
set prtfilperm permanent
set prtreversed ""
set b_quick 1; set b_spell 1; set b_syntax 1; set b_index 1; set b_bibliography 1
set b_additional 1; set b_logfile 1; set b_letters 0
set texmax 1
set whichcheck yes
set tlOverfull 0.0
set tlHBadness 500
set tlMaxLines 500
set tlDirIgnore /usr/local/texmf/
set Wtl .erroredit
set tlLastFile ""
set texloganalyze yes; set texlogatext "" ; set texlogopts "";
set quickfile XtemQuick
set exallowset 0
set textxscroll 0
set unlockbutt 0

set Wa .xtemak; set Wb .xtembv
set Wdm .xtemdm; set Wds .printpresel; set Wdv .xtemdv
set We .xtemev; set Wf .xtemfs; set Wh .syntaxhelp; set Wi .xtemiv
set Wl .xtemlv; set Wle .xtemle; set Wp .xtempv; set Wq .xtemq
set Wr .xtemrv; set Ws .xtemsv; set Wt .xtemtv
set Wo .xtemso; set Wx .xtemx


proc install_lesen {} {
  global vv env InstDir widthl widthr sizeds unlockbutt noWarnTcl
  global fontdli fontsli fontbl fontstdout fonterr fonterrtag fonted 
  global prtselmaxl prtselmaxc prtfilperm
  global maxprintcops vlerg hlp_font xtermcall edsyntaxhelp bell_level
  global texmax texmaxdef whichcheck geom button2end fsmenucols
  global b_quick b_spell b_syntax 1 b_index b_bibliography b_additional b_logfile b_letters
  global tlDirIgnore tlOverfull tlHBadness tlMaxLines quickfile exallowset textxscroll

  if [info exists env(XTEMINSTALL)] \
	{set f [open "$env(XTEMINSTALL)" r];  set InstDir "${InstDir} ($vv(xt1))\n"} \
  else  {set f [open_vst install.vst]}

  while {[getscl $f z]>0} {set [string trim [lindex $z 0]] [string trim [lrange $z 1 end]]}
  close $f
  set texmaxdef $texmax
}

install_lesen
set stt ""; setTclVersions; set p_mkCmd 1; # setting of the version and consequences
set version "${version}$status$patches$vlerg"; set version_vst "${version}"
set tlOfull $tlOverfull; set tlHBad  $tlHBadness; set tlMaxL  $tlMaxLines

set xtemTyh 30
set sub 0; set edsubback 0; set prsubback 0; set logsubback 0
set anl0 0
set pid ""; set xtAbbruch 0; set RequestActive 0

set editor vi; set edxterm xterm; set edoptions ""
set printer ""; set lpcmd lp; set lpopt ""; set olsep @
set prtdriver dvips; set prtoptions "" ;set prtsuf .ps
set prtpresel "* * * * * * * * * * * * * * * * * * * *"
set spcmd spell; set sptext ""; set splang english; set spcorr ""
set spselect ""; set spoptions ""
set bibtex bibtex; set bitext ""; set bioptions ""
set index makeindex; set intext ""; set inoptions ""; set syntax ""
set sytext ""; set syoptions ""
set preview ghostview&; set prtext ""; set prsuffix .ps; set proptions ""
set opsep @; set prpreopt ""
set texfmt latex; set texfmtt ""; set texmem ""; set texmtext ""
set quickenable 0; set quickverbatim ""; set quickprereq ""; set quickpreform ""
set quicksuffix ""; set quickpreamble ""; set quickendpre ""; set quickenddoc ""
set logform cat; set logxterm ""; set logoptions ""; set logtext ""
set aufmax 20
set aufsuff "*~ *.aux *.bak *.bbl *.blg *.dvi *.idx *.ilg *.ind *.lof *.log *.lot *.ps *.toc *.wb-erg"
set auftoggle " 1 1 1 0 1 0 1 1 0 1 1 1 0 1 1"
set mkcommand mkcommand.9
set hlp_bmsuppr 0
set prformat A4_portrait; set prtformat ""
set prtselstr ""; set pg_start 1; set pg_end 9999
set prmtext ""; set prmsel ""; set prmrelabs ""
set isuffe .idx; set isuffa .ind; set bsuff .aux
set edback ""; set edliste ""; set edtext ""
set prback ""; set prliste ""; set logliste ""
set tsuff ""; set psuff ""; set lsuff ".log"; set asuff ""; set spsuff ""; set ssuff ""

set vst_ret [vstRead "" start.vst]
if {$vst_ret!="0"} {
  set stt "${stt} $vv(xtq01)\n $vv(xtq01)\n $vv(xtq02)\n"
  set stt "${stt} $vv(xtq17)\n $vv(xtq18)\n $vv(xtq19)\n $vv(xtq20)\n"
  set stt "${stt} $vv(xtq02)\n $vv(xtq01)\n $vv(xtq01)\n"
  set stt "${stt}\n $vst_ret ---> $vst_ret.bak\n\n"
  mybell 2
  set vst_ret [vstRead "" .xtem_$language.vst]
  if {$vst_ret!="0"} {
    set stt "${stt}\n $vst_ret ---> $vst_ret.bak\n\n"
    vstRead "" default.vst
  }
}


set dir [pwd]

####################################################################;#####@@@@@Testweise
if {[tk appname]!="xtem"} {tk appname xtem1}; set appnm [tk appname];#####@@@@@Testweise!
####################################################################;#####@@@@@Testweise
if [info exists fontbl]   	    {option add ${appnm}*Button.Font          $fontbl
				     option add ${appnm}*Label.Font           $fontbl
				     option add ${appnm}*Checkbutton.Font     $fontbl
				     option add ${appnm}.font.normal.font     $fontbl}
if [info exists fontdli]	    {option add ${appnm}*Listbox.Font         $fontdli}
if [info exists fontsli]	    {option add ${appnm}$Wds*Listbox.Font     $fontsli
				     option add ${appnm}$Wds*selected.font    $fontsli
				     option add ${appnm}$Wds*Radiobutton.Font $fontsli}
if [info exists fontstdout]	    {option add ${appnm}*d.tt.font            $fontstdout}
if [info exists fonterr]	    {option add ${appnm}.font.error.font      $fonterr}
if [info exists fonterrtag]	    {option add ${appnm}*errortag.font        $fonterrtag}
if [info exists fonted] 	    {option add ${appnm}$Wtl.c.t.font         $fonted}
option add ${appnm}*Radiobutton.Pad 0
option add ${appnm}*Pad 1
option add *insertOffTime 0

if [info exists hlp_font(normal)]   {option add ${appnm}$Wh.normal.font   $hlp_font(normal)}
if [info exists hlp_font(tag)]      {option add ${appnm}$Wh.tag.font      $hlp_font(tag)}
if [info exists hlp_font(italic)]   {option add ${appnm}$Wh.italic.font   $hlp_font(italic)}
if [info exists hlp_font(bold)]     {option add ${appnm}$Wh.bold.font     $hlp_font(bold)}
if [info exists hlp_font(boldlrge)] {option add ${appnm}$Wh.boldlrge.font $hlp_font(boldlrge)}
if [info exists hlp_font(title)]    {option add ${appnm}$Wh.title.font    $hlp_font(title)}
if [info exists hlp_font(teletype)] {option add ${appnm}$Wh.teletype.font $hlp_font(teletype)}
if [info exists hlp_font(telelrge)] {option add ${appnm}$Wh.telelrge.font $hlp_font(telelrge)}
if [info exists hlp_font(telesmll)] {option add ${appnm}$Wh.telesmll.font $hlp_font(telesmll)}

if [info exists env(XTEMXDEFAULTS)] {
  set f "$env(XTEMXDEFAULTS)"; if {[string first "/" "$f"]<0} {set f "$env(HOME)/$f"}
  option readfile $f
  set xdf "$vv(xt27) $f\n"
} elseif [file exists $env(HOME)/.Xdefaults] {
  option readfile $env(HOME)/.Xdefaults
  set xdf "$vv(xt27) $env(HOME)/.Xdefaults\n"
} else {
  set xdf ""
}


set pys 0; # pady-value

wm iconname . "xtem";  wm title . "xtem";  wm minsize . 0 0
if [info exists geom(xtem)] {wm geometry . $geom(xtem)}

# Bereich a fuer erste Buttons

frame .a; pack configure .a -side top -anchor w -fill x

frame .a.1  -relief raised -borderwidth 1; pack configure .a.1  -side left -anchor w -pady 8
frame .a.11 -relief raised -borderwidth 1; pack configure .a.11 -side left -anchor c -expand 1
frame .a.2  -relief raised -borderwidth 1; pack configure .a.2  -side right -anchor e

								### Ende
button .a.1.e -text "$vv(ae)" -command {
  if {$mkcommand!="mkcommand.9"} {
    if [file exists $env(HOME)/.xtem_$language.vst] {
        vst_getvalues "" "$env(HOME)/.xtem_$language.vst"
        vst_write_file "$env(HOME)/.xtem_$language.vst"
    } else {
        vst_write_file "$env(HOME)/.xtem_$language.vst"
    }
    if [file exists ${main_file}_$language.vst] {
        vst_getvalues "" "${main_file}_$language.vst"
        vst_write_file "${main_file}_$language.vst"
    } 
  }
  if {$p_mkCmd>1} {
    if {[process $p_mkCmd]==0} {
	killprocess $p_mkCmd; mybell 2; writescr0 .d.tt "***** $vv(xt2)\n      $vv(xt3)\n\n\n"
    } else {DestroyAfterKillEtc "$prliste $logliste"; # no return}
  } else {DestroyAfterKillEtc "$prliste $logliste"; # no return}
}
Bind3HF .a.1.e xt_quit .d.tt


								### Hilfen
button .a.1.h -text "$vv(ah)" -command {xtem_hlptext}

								### Lschen Text-Feld
button .a.1.l -text "$vv(al)" -command {clearscr .d.tt}
Bind3HF .a.1.l z_loeschetf .d.tt

								### Grundstellung
button .a.1.g -text "$vv(ag)" -command {
  set oldsuff $texsuffix;  set oldesuff $esuff
  vstRead .d.tt default.vst
  if {$oldsuff!=$texsuffix} {set main_file ""}
  if {$oldesuff!=$esuff} {set efile $main_file; set esuff $texsuffix}
  MkcmdSource;  knoepfe
}
Bind3HF .a.1.g xt_grund .d.tt

pack configure .a.1.e .a.1.h .a.1.l .a.1.g -side left -padx 3 -pady 3


								### Entriegeln
if {$unlockbutt==1} {
 button .a.11.r -text "$vv(xta11r)" -command {unlock $gesliste};
 Bind3HF .a.11.r xt_entrieg .d.tt
 pack configure .a.11.r -side left -padx 3 -pady 3
}


								### exec-Modus
button .a.2.m -text "$vv(xta2m)" -command {CallSetMenu xv}
Bind2P .a.2.m 0 LeftMouseOnly .d.tt
Bind3HF .a.2.m xt_mkcmd .d.tt
pack configure .a.2.m -side bottom -padx 3 -pady 3


# Bereich b fuer eigene Voreinstellungen, TeX-Syntaxhilfen und lokale News

frame .b; pack configure .b -side top -anchor w -fill x

frame .b.1 -relief raised -borderwidth 1;  pack configure .b.1 -side left -anchor w
frame .b.2;				   pack configure .b.2 -side right -pady 6

label  .b.1.dv -text "$vv(bvdv)"  -width 20 -anchor w
button .b.1.va -text "$vv(bvva)" -command {writescr0 .d.tt "$vv(aus0)\n\n"; disp_prefs2 .d.tt}
button .b.1.vs -text "$vv(xtb1va)" -command {vst_write .d.tt}
button .b.1.vl -text "$vv(xtb1vl)" -command {vstReadDriver}
pack configure .b.1.dv .b.1.va .b.1.vs .b.1.vl -side left -padx 3 -pady 3
Bind3HF .b.1.dv xt_voreinst3 .d.tt
Bind3HF .b.1.va xt_voreinst3 .d.tt
Bind3HF .b.1.vs xt_voreinst3 .d.tt
Bind3HF .b.1.vl xt_voreinst3 .d.tt

button .b.2.ln -text "$vv(xtb2ln)" -command {xtemWb2ln}
pack configure .b.2.ln -side right -padx 3 -pady 3
Bind3HF .b.2.ln xt_localnews .d.tt

set TeXSyntaxHelpOwnButton 1
if {$TeXSyntaxHelpOwnButton==1} {
 button .b.2.ts -text "$vv(xtb2ts)" -command {TeX_syntax_help $texfmt 1}
 pack configure .b.2.ts -side right -padx 3 -pady 3
 Bind3HF .b.2.ts xt_syntxhlp .d.tt
 Bind3HF .a.1.h xt_help .d.tt
} else {
 Bind2P .a.1.h 1 TeX_syntax_help $texfmt 1
 Bind3P .a.1.h 0 xtem_hlptext
}


# Button-Bereich c fuer Aktionen und Bindungen

frame .c; pack configure .c -pady 8


# Button-Bereich .c.1 fuer Aktionen und Bindungen

frame .c.1; frame .c.2; pack configure .c.1 .c.2 -side left -padx 5 -anchor ne

								### Dateiauswahl
button .c.1.fs -text "$vv(xtc1fs)" -anchor w -width $widthl \
	-command {lock; set sub 1; fileselect}
Bind2P .c.1.fs 0 LeftMouseOnly .d.tt
Bind3HF .c.1.fs xt_filesel .d.tt

								### Editieren/Editor-Aufruf
button .c.1.ed -anchor w -width $widthl -command {
  lock;  set sub 1
  if {$edback=="&"} {
    set i [lsearch $liste .c.1.ed];  if {$i>=0} {set liste [lreplace $liste $i $i]}
    set edsubback 1
  }
  set pid 0;  editor .d.tt austext;  writescr .d.tt "$austext"
  if {$edback=="&"} {
    if {$pid!=0} {set edsubback $pid;  set edliste [linsert $edliste 1 $pid]} \
    elseif {[lsearch $liste .c.1.ed]<0} {set liste [linsert $liste 1 .c.1.ed]}
  }
  if {$edsubback==0} {if {[lsearch $liste .c.1.ed]<0} {set liste [linsert $liste 1 .c.1.ed]}}
  unlock_list; focus .
}
Bind2P .c.1.ed $exallowset CallSetMenu ev
Bind3HF .c.1.ed xt_editor .d.tt

								### Quick&Dirty
button .c.1.qd -anchor w -width $widthl -command {
  set res [catch "selection get -selection PRIMARY" mouse_grab]
  if {$res==1} {writescr0 .d.tt "\n$vv(xt38)\n"; mybell 2} \
  elseif {!$quickenable} {writescr0 .d.tt "\n$vv(xtc1qd) $vv(disabl) $vv(qd15)\n"; mybell 2} \
  else {lock; set sub 1; quick .d.tt austext; writescr .d.tt "$austext"; unlock_list; focus .}
}
Bind2P .c.1.qd 0 LeftMouseOnly .d.tt
Bind3HF .c.1.qd xt_quick .d.tt

								### TeX-Aufruf
button .c.1.la -anchor w -width $widthl -command {
  unlock_list; # Updating, falls zuletzt Editor verlassen!
  # lock;  set sub 1
  if ![file exists $main_file$tsuff] {set frage "TeX $vv(xt29) $main_file$tsuff   $vv(ea4)"}
  if {$main_file==""} {set frage "$vv(ea1)"}
  if {(![file exists $main_file$tsuff])||("$main_file"=="")} {
    if [winfo exists $Wq] {destror $Wq}; toplevel $Wq
    proc ReqTeXRYes {} {global Wq;destror $Wq; lock; set sub 1; runtex}
    proc ReqTeXRNo  {} {global Wq; destror $Wq; unlock_list}
    Request $Wq "$frage" "" "$vv(xt30)" ReqTeXRYes "$vv(xt31)" ReqTeXRNo te_datei ""
  } else {lock; set sub 1; runtex}
}
Bind2P .c.1.la $exallowset CallSetMenu tv
Bind3HF .c.1.la xt_tex .d.tt
proc tlDriver {w austext} {
  global vv main_file tlA tlLog tlEditActiveReq
  upvar 1 $austext a
  set a ""; set tlA ""; set tlLog $main_file.log
  if ![file exists $tlLog] {set a "${a}\n$vv(tlmlf): $tlLog\n"; mybell 2; return}
  set tlEditActiveReq 0; tla $w; set a "$tlA"
}
proc runtex {} {
  global vv texmax texrun sub texloganalyze tlFileCheck
  if {"$texmax">1} {set prs_alt [checksum]}
  set texrun 1
  set texerg [tex  .d.tt austext]; writescr .d.tt "$austext"
  if {$texerg!=1} {
    if {"$texmax">1} {
      while {"$texrun"<"$texmax"} {
        set prs_neu [checksum]
        writescr .d.tt "$vv(xt10)=$prs_alt, $vv(xt11)=$prs_neu\n"
        if {"$prs_neu"!="$prs_alt"} {
	  incr texrun
	  tex  .d.tt austext; writescr .d.tt "$austext"
	  set prs_alt $prs_neu
        } else {
	  writescr .d.tt "\n$vv(xt12)\n(\".aux\" $vv(xt13)\n";  break
        }
      }
      if {"$texrun"=="$texmax"} {
        set prs_neu [checksum]
        if {"$prs_neu"!="$prs_alt"} {
          writescr .d.tt "\n\n***** $vv(xt14)\n(\".aux\" $vv(xt15)\n";  mybell 2
        }
      }
    }
    lock; set sub 1
    tex_post  .d.tt austext; writescr .d.tt "$austext"
    if {$texloganalyze=="yes"} {
        lock; set sub 1
	writescr .d.tt "\n$vv(xt36) ...\n"; update
	set tlFileCheck 1;  tlDriver .d.tt austext;  writescr .d.tt "$austext"
    }
  }
  unlock_list; focus .
}

								### Preview-Aufruf
button .c.1.pf -anchor w -width $widthl -command { 
  lock;  set sub 1
  if {$prback=="&"} {
    set i [lsearch $liste .c.1.pf];  if {$i>=0} {set liste [lreplace $liste $i $i]}
    set prsubback 1
  }
  set pid 0
  preview  .d.tt austext; writescr .d.tt "$austext"
  if {$prback=="&"} {
    if {$pid!=0} {set prsubback $pid;  set prliste [linsert $prliste 1 $pid]} \
    elseif {[lsearch $liste .c.1.pf]<0} {set liste [linsert $liste 1 .c.1.pf]}
  }
  if {$prsubback==0} {if {[lsearch $liste .c.1.pf]<0} {set liste [linsert $liste 1 .c.1.pf]}}
  unlock_list
}
Bind2P .c.1.pf $exallowset CallSetMenu pv
Bind3HF .c.1.pf xt_preview .d.tt

								### Dvi2printer
button .c.1.as  -anchor w -width $widthl -command {
  lock;  set sub 1
  writescr0 .d.tt "[datime] $vv(xtc1as) $main_file\n"
  set austext ""
  case [mdtest [stripdir $main_file] $tsuff $asuff austext] {
   -1 {writescr .d.tt "$austext";  unlock_list; # $main_file or dvi-file doesn't exist}
    0 {# dvi-file and tex-file exist, but dvi-file is older
        if [winfo exists $Wq] {destror $Wq}; toplevel $Wq; set anl0 0
        set frage "$vv(aus5) $main_file$tsuff $vv(ut13) $main_file$asuff $vv(ut14)"
        proc ReqDviYes {} {global Wq; destror $Wq; dvi2printer}
        proc ReqDviNo  {} {global Wq; destror $Wq; unlock_list}
        Request $Wq "$frage" "" "$vv(xtrotz)" ReqDviYes "$vv(dmaa)" ReqDviNo dm_agedvitex ""
      }
    1 {writescr .d.tt "$austext";  dvi2printer; # dvi-Datei neuer oder keine tex-Datei}
  }
  focus .
}
Bind2P .c.1.as $exallowset CallSetMenu dv
Bind3HF .c.1.as xt_drucker .d.tt


button .c.1.au -text "$vv(xtc1au)" -anchor w -width $widthl -command {### Aufrumen
  lock;  set sub 1;  clear .d.tt
}
Bind2P .c.1.au 0 LeftMouseOnly .d.tt
Bind3HF .c.1.au xt_delauxs .d.tt


pack configure .c.1.fs .c.1.ed -pady $pys
if {($b_quick==1)} {pack configure .c.1.qd -pady $pys}
pack configure .c.1.la .c.1.pf .c.1.as .c.1.au -pady $pys


# Button-Bereich .c.2 fuer Aktionen und Bindungen

								### Rechtschreib-Prfung
button .c.2.re -anchor w -width $widthr -command {
  unlock_list; # Updating, falls zuletzt Editor verlassen!
  if {($spcorr=="K")&&($edsubback!=0)} {set frage "$vv(xt20) $vv(xt200)"} else {set frage ""}
  lock;  set sub 1
  if {$frage==""} {
    if {"$spselect"=="S"} rs
    spellcheck .d.tt austext; writescr .d.tt "$austext"
    unlock_list
  } else {
    if [winfo exists $Wq] {destror $Wq}; toplevel $Wq; set anl0 0
    proc ReqSpellYes {} {global Wq spselect
      destror $Wq
      if {"$spselect"=="S"} rs
      spellcheck .d.tt austext; writescr .d.tt "$austext"
      unlock_list
    }
    proc ReqSpellNo  {} {global Wq; destror $Wq; update idletasks; unlock_list}
    Request $Wq "$frage" "" "$vv(xt21)" ReqSpellYes "$vv(dmaa)" ReqSpellNo re_konflikt ""
  }
  focus .
}
Bind2P .c.2.re $exallowset CallSetMenu rv
Bind3HF .c.2.re xt_recht .d.tt

								### Syntax-Prfung
button .c.2.sy -anchor w -width $widthr -command \
   {lock;  set sub 1;  syntax .d.tt austext; writescr .d.tt "$austext";  unlock_list; focus .}
Bind2P .c.2.sy $exallowset CallSetMenu sv
Bind3HF .c.2.sy xt_syntax .d.tt

								### Index-Aufbereitung
button .c.2.in -anchor w -width $widthr -command \
   {lock;  set sub 1;  index .d.tt austext; writescr .d.tt "$austext";  unlock_list; focus .}
Bind2P .c.2.in $exallowset CallSetMenu iv
Bind3HF .c.2.in xt_index .d.tt

								### BibTeX/Bibliographie
button .c.2.bi -anchor w -width $widthr -command \
   {lock; set sub 1;  bibliogr .d.tt austext; writescr .d.tt "$austext"; unlock_list; focus .}
Bind2P .c.2.bi $exallowset CallSetMenu bv
Bind3HF .c.2.bi xt_bibtex .d.tt

								### Sonstige Programme
button .c.2.so -text "$vv(xtc2so)" -anchor w -width $widthr -command {
  if {$edsubback!=0} {set frage "$vv(xt20) $vv(xt201)"} else {set frage ""}
  lock;  set sub 1
  if {$frage==""} {
    if [winfo exists $Wo] {raise $Wo} else {so}
  } else {
    if [winfo exists $Wq] {destror $Wq}; toplevel $Wq; set anl0 0
    proc ReqUtilYes {} {global Wq Wo; destror $Wq; if [winfo exists $Wo] {raise $Wo} {so}}
    proc ReqUtilNo  {} {global Wq; destror $Wq; update idletasks; unlock_list}
    Request $Wq "$frage" "" "$vv(xt24)" ReqUtilYes "$vv(dmaa)" ReqUtilNo so_konflikt ""
  }
}
Bind2P .c.2.so 0 LeftMouseOnly .d.tt
Bind3HF .c.2.so xt_sonstige .d.tt


								### Protokolldatei anschauen
button .c.2.fl -text "$vv(xtc1fl)  $logform$logback  $main_file$lsuff" \
		-anchor w -width $widthr -command {
  if {$main_file==""} {writescr0 .d.tt "***** $vv(ea1)\n"
  } else {
    lock;  set sub 1;  set pid 0
    if {$logform=="tla"} {
      writescr0 .d.tt ""
      if [file exists $main_file.log] {cat_file $main_file.log .d.tt}
      if {$lsuff!=".log"} {writescr .d.tt "$vv(lv8) $main_file.log"} 
      writescr .d.tt "\n$vv(xt36) ...\n"; update
      set tlFileCheck 0;  tlDriver .d.tt austext;  writescr .d.tt "$austext"
    } else {
      logfile .d.tt austext;  writescr .d.tt "$austext"
    }
    if {($logback=="&")&&($pid!=0)} \
		{set logsubback $pid; set logliste [linsert $logliste 1 $pid]}
    unlock_list; focus .
  }
}
Bind2P .c.2.fl $exallowset CallSetMenu lv
Bind3HF .c.2.fl xt_seelogs .d.tt

								### letters/reports
button .c.2.le -anchor w -width $widthr -command \
    {source le.tcl; unlink -nocomplain zz.tex; if {$main_file!=""} {lock; set sub 1; letters} else {writescr0 .d.tt "***** $vv(ea1)\n"}}
Bind2P .c.2.le 0 LeftMouseOnly .d.tt
Bind3HF .c.2.le xt_letters .d.tt


if {$b_spell} {pack configure .c.2.re -pady $pys}
if {$b_syntax} {pack configure .c.2.sy -pady $pys}
if {$b_index} {pack configure .c.2.in -pady $pys}
if {$b_bibliography} {pack configure .c.2.bi -pady $pys}
if {$b_additional} {pack configure .c.2.so -pady $pys}
if {$b_logfile} {pack configure .c.2.fl -pady $pys}
if [crange $b_letters 0 0] {pack configure .c.2.le -pady $pys}


dirMainFile;  knoepfe

set gesliste [list .a.1.e  .a.1.h  .a.1.l  .a.1.g .a.2.m \
	           .b.1.va .b.1.vs .b.1.vl .b.2.ln \
	           .c.1.fs .c.1.ed .c.1.qd .c.1.la .c.1.pf .c.1.as .c.1.au \
	           .c.2.re .c.2.sy .c.2.in .c.2.bi .c.2.so .c.2.fl .c.2.le]
set liste $gesliste


InsertTextFrame "" $xtemTyh
frame .font; label .font.error; label .font.errortag; label .font.normal
.d.tt tag configure err -font [option get .font.error font text]
.d.tt tag configure end -relief raised -borderwidth 1 -background white


# final checks

if {$extended==""} {
  set mkcommand "mkcommand.0"
  set stt "${stt}$vv(xtq11)\n$vv(xtq12)\n$vv(xtq13)\n"
  set stt "${stt}$vv(xtq14)\n$vv(xtq15)\n$vv(xtq16)\n"
  set stt "${stt}______________________________________________\n\n"
  MkcmdSource
} else {
  MkcmdSource
  if {$mkcommand=="mkcommand.9"} {
    mybell 3
    set stt "${stt} $vv(xtq01)\n $vv(xtq01)\n $vv(xtq02)\n"
    set stt "${stt} $vv(xtq1)\n $vv(xtq2)\n $vv(xtq3)\n $vv(xtq4)\n"
    set stt "${stt} $vv(xtq02)\n $vv(xtq01)\n $vv(xtq01)\n"
    set stt "${stt}\n"
  }
}

if {$stt!=""} {writescr0 .d.tt $stt; mybell 3}

if {$tclversion>=7.5} {set tpt "[array get tcl_platform]"} else {set tpt ""}
TestPut 4 "xtem started with test output:\n\t\
    xtem:$version Tcl:$patchlevel Tk:$tk_patchLevel $extended $addinput $mkcommand\n\t\
    $tpt\n\tInstDir: $InstDir\n\t${xdf}\n\t$vv(xt28) $vstdat\n<$stt>\n"
if {$testPut==1} {set bell_level 0}

if {($main_file=="")||([testfilename $main_file .d.tt $texsuffix])} \
	{writescr .d.tt "\n$vv(xt26)\n"}
writescr .d.tt "\n${xdf}$vv(xt28) $vstdat\n"
if [file exists  "$xtem_path/../xtem_locals_$language/xtemstart_news"] \
	{set sfl "$xtem_path/../xtem_locals_$language/xtemstart.news"} \
else    {set sfl "$xtem_path/locals_$language.LRW/xtemstart.news"}
if [file exists $sfl] {writescr .d.tt "\n"; cat_file $sfl .d.tt}; .d.tt yview 0
if {[winfo exists $Wq]} {raise $Wq}

signal trap SIGCHLD {mkCmd_fin}

signal trap [list SIGSEGV SIGBUS] {
  puts stderr "signal %S received"
  puts stderr ""
  puts stderr "Is signal trap SIGCHLD in your release of Tcl7.4 OK?"
  puts stderr "Check this by two commands after a call of wishx in an xterm window:"
  puts stderr "> signal trap SIGCHLD {puts stdout \"***** sigchld correctly executed *****\"}"
  puts stderr "> exec ls -C"
  puts stderr ""
  puts stderr "(we had to modify the Tcl source code in order to avoid an abort:"
  puts stderr " in file  \"tclUnixUtil.c\" one line has to be changed"
  puts stderr " from:"
  puts stderr "           pid = vfork ();"
  puts stderr " to:"
  puts stderr "           pid = fork ();"
  puts stderr ")"
  puts stderr ""
  puts stderr "Please inform us ($email) if necessary and specify Tcl/Tk version and system"
  exit
}
